//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:mega_spi.c
//
//  PB0(SS)  : SPI-SS
//  PB1(SCK) : SPI-SCK
//  PB2(MOSI): SPI-MOSI(Mega328:out, DS3234:in)
//  PB3(MISO): SPI-MISO(Mega328:in,  DS3234:out)
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************

#include	<avr/io.h>

#include	"six_in17_clock2.h"
#include	"port_bit.h"
#include	"mega_spi.h"


// ************************************
// SPI ݒ
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	spi_init(void)
{
	// |[gݒ
	PORTB |= (1 << PB0);								// SS=H
	DDRB  |= ((1 << DDB0) | (1 << DDB1) | (1 << DDB2));	// SS,MOSI,SCK o͂ɂ
	DDRB  &= ~(1 << DDB3);								// MISO ͂ɂ

	// rohݒ
//	PRR &= ~(1 << PRSPI);																		// SPIғ
	SPCR = ((1 << SPE) | (1 << MSTR) | (1 << CPOL) | (1 << CPHA) | (1 << SPR1) | (0 << SPR0));	// spiғA}X^[A[hRAfosc/64 = 125kHz
	SPSR = (0 << SPI2X);																		// fosc/64 = 125kHz

}

// ************************************
// SPI Jn
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void	spi_start(void)
{
	PORTB &= ~(1 << PB0);								// SS=L
}

// ************************************
// SPI ~
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void spi_stop(void)
{
	PORTB |= (1 << PB0);								// SS=H
}

// ************************************
// SPI ǂݏ
//     data: ݃f[^
//  ߂lFǏof[^
//
// ************************************
unsigned char	spi_rd_wr(unsigned char data)
{
	SPDR = data;							// ݃f[^ f[^WX^ɃZbg
	while ((SPSR & (1 << SPIF)) == 0){		// SPIF PɂȂ܂ő҂
		;
	}
	return(SPDR);
}
