//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:nixie.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************

#include	<avr/pgmspace.h>
#include	<avr/io.h>

#include	"six_in17_clock2.h"
#include	"nixie.h"

// **********************************************************
// *********************** NIXE TUBE ************************
// **********************************************************
//

// **********************************************************
//@jLV[ǂ͂O`TÂUiR͂Ȃj
//@@odQ`ṼrbgɂđI
//@@@V@U@T@S@R@Q
//@@@g@k@k@k@k@k@||@U@@̏㌅
//@@@k@g@k@k@k@k@||@T@@̉
//@@@k@k@g@k@k@k@||@S@@̏㌅
//@@@k@k@k@g@k@k@||@R@@̉
//@@@k@k@k@k@g@k@||@Q@@b̏㌅
//@@@k@k@k@k@k@g@||@P@@b̉
//
//   Nixie Tube Select by PE2--PE7
//   PE 7 6 5 4 3 2 
//      H L L L L L  --> E6 Nixie Select hour H
//      L H L L L L  --> E5 Nixie Select hour L
//      L L H L L L  --> E4 Nixie Select minute H
//      L L L H L L  --> E3 Nixie Select minute L
//      L L L L H L  --> E2 Nixie Select second H
//      L L L L L H  --> E1 Nixie Select second L
//
//@@@AAb@
//@@\lobO@||@obVCocUCocV̂POrbgōs
//@@@obO@obP@obQ@obR@obS@obT@obU@obV@ocU@ocV
//@@@g@@@k@@@k@@@k@@@k@@@k@@@k@@@@@k@@@k@@@k@@||@O
//@@@k@@@g@@@k@@@k@@@k@@@k@@@k@@@@@k@@@k@@@k@@||@P
//@@@k@@@k@@@g@@@k@@@k@@@k@@@k@@@@@k@@@k@@@k@@||@Q
//@@@k@@@k@@@k@@@g@@@k@@@k@@@k@@@@@k@@@k@@@k@@||@R
//@@@k@@@k@@@k@@@k@@@g@@@k@@@k@@@@@k@@@k@@@k@@||@S
//@@@k@@@k@@@k@@@k@@@k@@@g@@@k@@@@@k@@@k@@@k@@||@T
//@@@k@@@k@@@k@@@k@@@k@@@k@@@g@@@@@k@@@k@@@k@@||@U
//@@@k@@@k@@@k@@@k@@@k@@@k@@@k@@@@@g@@@k@@@k@@||@V
//@@@k@@@k@@@k@@@k@@@k@@@k@@@k@@@@@k@@@g@@@k@@||@W
//@@@k@@@k@@@k@@@k@@@k@@@k@@@k@@@@@k@@@k@@@g@@||@X
//@@@k@@@k@@@k@@@k@@@k@@@k@@@k@@@@@k@@@k@@@k@@||@󔒁i\j
//
//   Number Display Select by PC0--PC7,PD6,PD7
//     PC0 PC1 PC2 PC3 PC4 PC5 PC6 PC7 PD6 PD7
//     H   L   L   L   L   L   L   L   L   L  -->Display '0'
//     L   H   L   L   L   L   L   L   L   L  -->Display '1'
//     L   L   H   L   L   L   L   L   L   L  -->Display '2'
//     L   L   L   H   L   L   L   L   L   L  -->Display '3'
//     L   L   L   L   H   L   L   L   L   L  -->Display '4'
//     L   L   L   L   L   H   L   L   L   L  -->Display '5'
//     L   L   L   L   L   L   H   L   L   L  -->Display '6'
//     L   L   L   L   L   L   L   H   L   L  -->Display '7'
//     L   L   L   L   L   L   L   L   H   L  -->Display '8'
//     L   L   L   L   L   L   L   L   L   H  -->Display '9'
//     L   L   L   L   L   L   L   L   L   L  -->Not Display ' '
// **********************************************************

unsigned char	path_limit = 1;
unsigned char	change_path = 2;

static	unsigned char	nixie_data_PC[KETA_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_data_PD[KETA_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_act_num = 0;
static	unsigned char	dynamic_nixie = 0;
static	unsigned char	nixie_data_dot;					// hbg\f[^
static	unsigned char	nixie_data_day_of_week;			// j\f[^

// ===================== jLV[ǁ@\ ==============//
// ------------ jLV[ǁ@I --------------
static	unsigned char	nixie_select[KETA_MAX+1]={		// \I
								0b10000000,				// ŏʁ@̏㌅
								0b01000000,				// Qʁ@̉
								0b00100000,				// Rʁ@̏㌅
								0b00010000,				// Sʁ@̉
								0b00001000,				// Tʁ@b̏㌅
								0b00000100,				// ŉʁ@b̉
												};

// ------------ jLV[ǁ@I --------------
static	unsigned char	nixie_number_PC[10]={			// PC0-7
								0b00000001,				// Number display '0'
								0b00000010,				// Number display '1'
								0b00000100,				// Number display '2'
								0b00001000,				// Number display '3'
								0b00010000,				// Number display '4'
								0b00100000,				// Number display '5'
								0b01000000,				// Number display '6'
								0b10000000,				// Number display '7'
								0b00000000,				// Number display '8'
								0b00000000,				// Number display '9'
												};
static	unsigned char	nixie_number_PD[10]={			// PD6-7
								0b00000000,				// Number display '0'
								0b00000000,				// Number display '1'
								0b00000000,				// Number display '2'
								0b00000000,				// Number display '3'
								0b00000000,				// Number display '4'
								0b00000000,				// Number display '5'
								0b00000000,				// Number display '6'
								0b00000000,				// Number display '7'
								0b01000000,				// Number display '8'
								0b10000000,				// Number display '9'
												};
// -------------------------------------------------
// =====================================================//

// --------- j\f[^ ----------
static	unsigned char	day_of_week_PA[7]={				// PA0-6
								0b00000001,				// SUN 0
								0b00000010,				// MON 1
								0b00000100,				// TUE 2
								0b00001000,				// WED 3
								0b00010000,				// THU 4
								0b00100000,				// FRI 5
								0b01000000,				// SAT 6
												};

#define		NIXE_SELECT_DIS		0b00000011	// PE2 -- 7 = all 0
#define		NIXE_NUMBER_OFF_PC  0b00000000	// PC0--7:'L'
#define		NIXE_NUMBER_OFF_PD  0b00111111	// PD6,PD7:'L'

#define		LED_DPR_ON			0b10000000	// PB7:'H'
#define		LED_DPL_ON			0b01000000	// PB6:'H'
//******************************
//  Nixe\@
// *****************************
void	init_nixe(void)
{
	unsigned char	uc;

	PORTE &= NIXE_SELECT_DIS;					// IȂ


	PORTC &= NIXE_NUMBER_OFF_PC;				// Ȃ
	PORTD &= NIXE_NUMBER_OFF_PD;				// Ȃ
	PORTB &= ~(LED_DPR_ON);						// q|cnsȂ
	PORTB &= ~(LED_DPL_ON);						// k|cnsȂ
	PORTA =  0x00;								// j\Ȃ

	DDRE |= ((1 << DDE2) | (1 << DDE3) | (1 << DDE4) | (1 << DDE5) | (1 << DDE6) | (1 << DDE7));	// Port-E Bit1,234567 : Output
	DDRD |= ((1 << DDD6) | (1 << DDD7));															// Port-D Bit1,67 : Output
	DDRC |= ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7));	// Port-C Bit01234587 : Output
	DDRB |= ((1 << DDB6) | (1 << DDB7));															// Port-B Bit67 : Output
	DDRA |= ((1 << DDA0) | (1 << DDA1) | (1 << DDA2) | (1 << DDA3) | (1 << DDA4) | (1 << DDA5) | (1 << DDA6) | (1 << DDA7));	// Port-A Bit01234567 : Output

// \AR f[^
	for(uc = 0;uc <= KETA_MAX; uc++){
		nixie_data_PC[uc] = NIXE_NUMBER_OFF_PC;	// NA
		nixie_data_PD[uc] = NIXE_NUMBER_OFF_PD;	// NA
	}

	nixie_act_num = 0;

	dynamic_nixie = 0;
}
//******************************
// jLV[Ǖ\
// sQ̊荞݂ŌĂ΂
//  for six in-17 Clock
//******************************
void	proc_dynamic_nixie(void)
{
	static	unsigned char	path=0;

	if(dynamic_nixie == 1){
		if(path == path_limit){

			PORTE &= NIXE_SELECT_DIS;					// IȂ

			PORTC &= (NIXE_NUMBER_OFF_PC);				// Ȃ
			PORTD &= (NIXE_NUMBER_OFF_PD);				// Ȃ
			PORTB &= ~(LED_DPL_ON | LED_DPR_ON);		// Dot-LR : OFF

			if(nixie_act_num == (KETA_MAX+1)){			// hbg
				PORTB |= nixie_data_dot;				// Dot-LR : ON
			}else if(nixie_act_num <= KETA_MAX){		// ijLV[ǁj
				PORTC |= nixie_data_PC[nixie_act_num];	// 
				PORTD |= nixie_data_PD[nixie_act_num];	// 
				PORTE |= nixie_select[nixie_act_num];	// I
			}

			PORTA = 0x00;								// No Display
			PORTA |= (day_of_week_PA[nixie_act_num] & nixie_data_day_of_week);		// Display


			if(KETA_MAX+1 <= nixie_act_num){
				nixie_act_num = 0;
			}else{
				nixie_act_num++;
			}

		}else if(path == 0){
			PORTC &= NIXE_SELECT_DIS;					// IȂ

			PORTC &= NIXE_NUMBER_OFF_PC;				// Ȃ
			PORTD &= NIXE_NUMBER_OFF_PD;				// Ȃ

			PORTB &= ~(LED_DPL_ON | LED_DPR_ON);		// Dot-LR : OFF
			PORTA = 0x00;								// day of week all off

		}

		path++;
		if(PATH_MAX+1 < path){
			path = 0;
		}

	}
}

//******************************
// Dynamic Nixie display Active/Non active
//  on : 1= Active, other=Non Active
// *****************************
void	dynamic_nixie_active(unsigned char on)
{
	dynamic_nixie = on;
}

//******************************
// Nixie \i_Ci~bN_j
//  k : ʒuiO`TAOFŏʁEEETFŉʁj
//  n : O`XAiPOȏ͋󔒁j
// *****************************
void	disp_dynamic_nixie_number(unsigned char k, unsigned char n)
{

	unsigned char old_dynamic_nixie;

	old_dynamic_nixie = dynamic_nixie;		// ܂ł̃_Ci~bN\̏Ԃۑ

	if(KETA_MAX < k){						// IlُȎ
		k = 0;								// Iɍŏʂɂ
	}

	dynamic_nixie = 0;						// _Ci~bN\~

	if(9 < n){
		nixie_data_PC[k] = 0x00;				// NA
		nixie_data_PD[k] = 0x00;				// NA
	}else{
		nixie_data_PC[k] = nixie_number_PC[n];
		nixie_data_PD[k] = nixie_number_PD[n];
	}

	dynamic_nixie = old_dynamic_nixie;		// ȑÕ_Ci~bN\̏Ԃɖ߂
}

// *****************************
// Nixie c|k\i_Ci~bN_j
//  on : O(OFF) or 1(ON)
// *****************************
void	disp_dynamic_dotl_on_off(unsigned char on)
{
	if(on == 0){
		nixie_data_dot &= ~LED_DPL_ON;	// hbg\f[^ OFF
	}else{
		nixie_data_dot |= LED_DPL_ON;	// hbg\f[^ ON
	}
}
// *****************************
// Nixie c|q\i_Ci~bN_j
//  on : O(OFF) or 1(ON)
// *****************************
void	disp_dynamic_dotr_on_off(unsigned char on)
{
	if(on == 0){
		nixie_data_dot &= ~LED_DPR_ON;	// Ehbg\f[^ OFF
	}else{
		nixie_data_dot |= LED_DPR_ON;	// Ehbg\f[^ ON
	}
}

// *****************************
// Nixie j\i_Ci~bN_j
//  w : Oijj||Uiyjj
//  wj_
//  Vȏ͑S
// *****************************
void	disp_dynamic_day_of_week(unsigned char w)
{
	if(w <= 6){
		nixie_data_day_of_week = day_of_week_PA[w];		// j\f[^ on
	}else{
		nixie_data_day_of_week = 0x00;					// j\f[^ all off
	}
}

//******************************
// j]\i_Ci~bN_j
//  w : Oijj||Uiyjj
//  wj
//  Vȏ͑S_
// *****************************
void	disp_dynamic_day_of_week_complement(unsigned char w)
{
	if(w <= 6){
		nixie_data_day_of_week = ~(day_of_week_PA[w]);		// j\f[^ off
	}else{
		nixie_data_day_of_week = ~(0x00);					// j\f[^ all on
	}
}

//******************************
// jS_i_Ci~bN_j
// *****************************
void	disp_dynamic_day_of_week_all_on(void)
{
	nixie_data_day_of_week = ~(0x00);						// all Display
}

//******************************
// jSi_Ci~bN_j
// *****************************
void	disp_dynamic_day_of_week_all_off(void)
{
	nixie_data_day_of_week = 0x00;							// No Display
}


//******************************
// Nixie \Si_Ci~bN_j
// *****************************
void	disp_dynamic_nixie_clear(void)
{
	unsigned char uc;

	for(uc=0;uc <= KETA_MAX; uc++){
		disp_dynamic_nixie_number(uc, 15);		//   
	}
}

//******************************
// Nixie \iX^eBbN_j
//  k : ʒuiO`TAOFŏʁEEETFŉʁj
//  n : O`XAPTiPT͋󔒁j
//   _Ci~bN\͍sĂȂԂɌ
// *****************************
void	disp_static_nixie_number(unsigned char k, unsigned char n)
{

	PORTE &= NIXE_SELECT_DIS;			// IȂ

	PORTC &= (NIXE_NUMBER_OFF_PC);		// Ȃ
	PORTD &= (NIXE_NUMBER_OFF_PD);		// Ȃ

	if(KETA_MAX < k){					// IlُȎ
		k = 0;							// Iɍŏʂɂ
	}

	if(n <= 9){
		PORTC |= nixie_number_PC[n];	// 
		PORTD |= nixie_number_PD[n];	// 
	}
	PORTE |= nixie_select[k];			// I


}
//******************************
// Nixie c|q\iX^eBbN_j
//  n : O(OFF) or 1(ON)
// *****************************
void	disp_static_dotr_on_off(unsigned char n)
{
	if(n == 0){
		PORTB &= ~(LED_DPR_ON);			// Dot-R : OFF
	}else{
		PORTB |= LED_DPR_ON;			// Dot-R : ON
	}
}
//******************************
// Nixie c|k\iX^eBbN_j
//  n : O(OFF) or 1(ON)
// *****************************
void	disp_static_dotl_on_off(unsigned char n)
{
	if(n == 0){
		PORTB &= ~(LED_DPL_ON);			// Dot-L : OFF
	}else{
		PORTB |= LED_DPL_ON;			// Dot-L : ON
	}
}

//******************************
// j\iX^eBbN_j
//  n:0(sun) <--> 6(sat)
// *****************************
void	disp_static_day_of_week(unsigned char w)
{
	if(w <= 6){
		PORTA = day_of_week_PA[w];		// Display
	}else{
		PORTA = 0x00;					// No Display
	}
}

//******************************
// j]\iX^eBbN_j
//  n:0(sun) <--> 6(sat)
// *****************************
void	disp_static_day_of_week_complement(unsigned char w)
{
	if(w <= 6){
		PORTA = ~(day_of_week_PA[w]);		// Display
	}else{
		PORTA = ~(0x00);					// No Display
	}
}

//******************************
// jS_iX^eBbN_j
// *****************************
void	disp_static_day_of_week_all_on(void)
{
	PORTA = ~(0x00);						// all Display
}

//******************************
// jSiX^eBbN_j
// *****************************
void	disp_static_day_of_week_all_off(void)
{
	PORTA = 0x00;						// No Display
}

