//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:uart.c
//
//  M̂ݎgp
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"six_in17_clock2.h"
#include	"timer.h"
#include	"eep_dat.h"
#include	"uart.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************

#define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)


// ********************** UART0 *****9600bos****************
unsigned char	rxd0_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd0_pos = 0;
unsigned char	read_rxd0_pos = 0;
unsigned short	gBPS0_9600 = BPS_600/16;


// ********************** UART1 *****600bps*****************
unsigned char	rxd1_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd1_pos = 0;
unsigned char	read_rxd1_pos = 0;
unsigned short	gBPS1_600 = BPS_600;



//***************************
// UART0 Initial
//***************************
void	uart0_init(void)
{
//	PRR &= ~(1 << PRUSART0);						// UART0 ғ
	delay_2us(100/2);								// POOr҂

	gBPS0_9600 = read_eep_bps_600()/16;				//@ddoqnl BPS_600 ǂݍ

	UBRR0H  = (unsigned char)(gBPS0_9600 >> 8);		// aor High
	UBRR0L  = (unsigned char)gBPS0_9600;			// aor Low

	UCSR0C = (V_PARITY0_NON | V_DATA0_8);			// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;

}
//***************************
// UART0 Close
//***************************
void	uart0_close(void)
{
	UCSR0B = 0x00;
	delay_2us(100/2);								// POOr҂
}
//***************************
// UART0 Pause
//***************************
void	uart0_pause(void)
{
	UCSR0B &= ~V_UCSR0B_RXEN;
	delay_2us(100/2);								// POOr҂
}
//***************************
// UART0 Restart
//***************************
void	uart0_restart(void)
{
	UCSR0B |= V_UCSR0B_RXEN;
	delay_2us(100/2);								// POOr҂
}
#if	1
//***************************
// UART0 TxD One Char
//  荞݂gȂ
//***************************
void	uart0_tx_one(unsigned char uc)
{
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;
}
//***************************
// UART TxD String
//  荞݂gȂ
//***************************
void	uart0_tx_str(char *str)
{
	while(*str != 0){
		uart0_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART TxD String + CR + LF
//***************************
void	uart0_tx_str_crlf(char *str)
{
	uart0_tx_str(str);											// UART TxD String
	uart0_tx_one(0x0d);											// CR
	uart0_tx_one(0x0a);											// LF
}
#endif

//***************************
// UART0 RXD Interrupt
//***************************
ISR	(USART0_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR0A & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)) );	// G[Ԏ擾
	uc = UDR0;											// Mf[^擾

	tim_10ms_uart = 10;									// kdc_

	if(er == 0){										// G[
		wr_pos = write_rxd0_pos;
		rxd0_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd0_pos){					// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd0_pos = wr_pos;
		}
	}
}
//***************************
// RXD0 Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd0(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd0_pos == read_rxd0_pos){					// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd0_data[read_rxd0_pos];						// Mf[^obt@擾
		read_rxd0_pos++;
		read_rxd0_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}


//***************************
// UART1 Initial
//***************************
void	uart1_init(void)
{
	delay_2us(100/2);								// POOr҂

	gBPS1_600 = read_eep_bps_600();					//@ddoqnl BPS_600 ǂݍ

	UBRR1H  = (unsigned char)(gBPS1_600 >> 8);		// aor High
	UBRR1L  = (unsigned char)gBPS1_600;				// aor Low

	UCSR1C = (V_PARITY1_NON | V_DATA1_8);			// peBAf[^

	UCSR1A = V_UCSR1A;
	UCSR1B = V_UCSR1B;

}
//***************************
// UART1 Close
//***************************
void	uart1_close(void)
{
	UCSR1B = 0x00;
	delay_2us(100/2);											// POOr҂
}
#if	1
//***************************
// UART1 TxD One Char
//  荞݂gȂ
//***************************
void	uart1_tx_one(unsigned char uc)
{
	while((UCSR1A & (1 << UDRE1)) == 0){
		;
	}
	UDR1 = uc;
}
//***************************
// UART1 TxD String
//  荞݂gȂ
//***************************
void	uart1_tx_str(char *str)
{
	while(*str != 0){
		uart1_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART1 TxD String + CR + LF
//***************************
void	uart1_tx_str_crlf(char *str)
{
	uart1_tx_str(str);								// UART TxD String
	uart1_tx_one(0x0d);								// CR
	uart1_tx_one(0x0a);								// LF
}
#endif

//***************************
// UART1 RXD Interrupt
//***************************
ISR	(USART1_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR1A & ((1<<FE1)|(1<<DOR1)|(1<<UPE1)) );	// G[Ԏ擾
	uc = UDR1;											// Mf[^擾

	tim_10ms_uart = 10;									// kdc_

	if(er == 0){										// G[
		wr_pos = write_rxd1_pos;
		rxd1_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd1_pos){					// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd1_pos = wr_pos;
		}
	}

}
//***************************
// UART1 RXD1 Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd1(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd1_pos == read_rxd1_pos){					// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd1_data[read_rxd1_pos];						// Mf[^obt@擾
		read_rxd1_pos++;
		read_rxd1_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

